# CC0

CC0 is a [waiver](waiver.md) (similar to a [license](license.md)) of copyright, created by [Creative Commons](creative_commons.md), that can be used to dedicate one's work to the [public domain](public_domain.md).

Unlike a license, a waiver such as this *removes* the author's copyright; by using CC0 the author willingly gives up his own copyright so that the work will no longer be owned by anyone (while a license preserves the author's copyright while granting some rights to other people). It's therefore the most [free](free_software.md) and [permissive](permissive.md) option for releasing intellectual works. CC0 is designed in a pretty sophisticated way, it also waives "neighboring rights" ([moral rights](moral_rights.md)), and also contains a fallback license in case waiving copyright isn't possible in a certain country. For this CC0 is one of the best ways, if not the best, of truly and completely dedicating works to public domain world-wide (well, at least in terms of copyright). In this world of extremely fucked up [intellectual property](intellectual_property.md) laws it is not enough to state "my work is public domain" -- you need to use something like CC0 to achieve legally valid public domain status.

CC0 is recommended by [LRS](lrs.md) for both programs and other art -- however for programs additional waivers of [patents](patent.md) should be added as CC0 doesn't deal with patents. CC0 is endorsed by the [FSF](fsf.md) but not [OSI](osi.md) (who rejected it because it explicitly states that trademarks and patents are NOT waived).

## Things Under CC0

Here are some things and places with CC0 materials that you can use in your projects so that you can release them under CC0 as well. **BEWARE**: if you find something under CC0, do verify it's actually valid, normies often don't know what CC0 means and happily post derivative works of proprietary stuff under CC0.

TODO

- software:
  - much of [LRS](lrs.md) sofware: [Anarch](anarch.md), [small3dlib](small3dlib.md), [raycastlib](raycastlib.md), [SAF](saf.md), ...
- other assets:
  - many things on [Wikimedia Commons](wikimedia_commons.md)
  - many things on opengameart
  - many things on BlendSwap
  - all of [drummyfish's](drummyfish.md) stuff including fonts, textures, 3D models etc.
  - [librivox](librivox.md) creates CC0 audiobooks from old books
- text:
  - [Esolang Wiki](esolang.md)
  - OSdev Wiki [since 2011](https://wiki.osdev.org/OSDev_Wiki:Copyrights)