# Free Software

Free (as in freedom) software is a type of [software](software.md) that's respecting its users' freedom, generally by availability of its source code and by a license that allows anyone to use, study, modify and share the software. It stands opposed to the [proprietary software](proprietary_software.md). Free software is not to be confused with [freeware](freeware.md) ("gratis", software available for free); although free software is always available for free thanks to its definition, zero price is not its goal. The goal is freedom.

Free software is also known as *free as in freedom* or *free as in speech* software. It is sometimes equated with [open source](open_source.md), even though open source is fundamentally different, or neutrally labelled FOSS (free and open-source software). Software that is gratis is sometimes called *free as in beer*.

# Definition

Free software was originally defined by [Richard Stallman](rms.md) for his [GNU](gnu.md) project. The definition was subsequently adjusted by other groups such as Debian and so nowadays there isn't a completely solid definition. However, all of these definition are very similar and are basically variations and subsets of the original one. The GNU definition of free software is paraphrased as follows:

Software is considered free if all its users have the rights to:

0. Use the software for any purpose.
1. Study the software. For this source code of the program has to be available.
2. Share the software with anyone.
3. Modify the software. This modified version can also be shared with anyone.

The developers of Debian operating system have created their own guidelines (Debian Free Software Guidelines) which respect these points but are worded in more complex terms and further require e.g. non-functional data to be available under free terms as well ([source](https://people.debian.org/~bap/dfsg-faq.html#not_just_code)) which GNU doesn't ([source](https://www.gnu.org/distros/free-system-distribution-guidelines.en.html#non-functional-data)). The definition of open source is yet more complex even though in practice free software is eventually also open source and vice versa.

# History

Free software was invented by the great [Richard Stallman](rms.md) in the 1980s. His free software movement inspired later movements such as the [free culture](free_culture.md) movement and the evil [open-source](open_source.md) movement.

# See Also

- [open source](open_source.md)
- [free culture](free_culture.md)
