# Linux

Linux is a [FOSS](foss.md) [unix-like](unix_like.md) [operating system](operating_system.md) [kernel](kernel.md), probably the most successful and famous non-[proprietary](proprietary.md) kernel. Linux is NOT a whole operating system, only its basic part -- for a whole operating system more things need to be added, such as some kind of [user interface](ui.md) and actual user programs, and this is what [Linux distributions](linux_distro.md) do (there are dozens, maybe hundreds of these) -- Linux distributions, such as [Debian](debian.md), [Arch](arch.md) or [Ubuntu](ubuntu.md) are complete operating systems (but beware, most of them are not fully [FOSS](foss.md)).

Linux is typically combined with a lot of [GNU](gnu.md) software and the [GNU](gnu.md) project (whose goal is to create a [free](free_software.md) OS) uses Linux as its official kernel, so in the wild we usually encounter the term [GNU/Linux](gnu_linux.md). Some people just can't be bothered to acknowledge the work of GNU and just call GNU/Linux systems "Linux" (without GNU/). **Fuck them**.

Linux is sometimes called [free as in freedom](free_software.md), however it is hardly deserving the label, it is more of an [open-source](open_source.md) or [FOSS](foss.md) project because:

- It actually includes [proprietary](proprietary.md) software in the form of [binary blobs](blob.md) ([drivers](drivers.md)). The [Linux-libre](linux_libre.md) project tries to fix this.
- It's development practices are [sus](sus.md), it is involved with many unethical corporations (through the [linux foundation](linux_foundation.md)) including [Microsoft](microsoft.md) (one of the greatest enemies of free software) who is trying to take control over it, [Google](google.md), [Intel](intel.md), [IBM](ibm.md) and others. It includes a fascist [code of conduct](coc.md) (`linux/Documentation/process/code-of-conduct.rst`).
- It doesn't really enforce it's license ([GPL](gpl.md)) legally -- we're not advocating legal battles, but the fact that they entertain a license and then don't use it indicates it may be there just for good image.
- It is [bloat](bloat.md) and in some ways [capitalist software](capitalist_software.md) (just try to fork Linux, maintain it and add/modify actual features).

Nevertheless, despite its mistakes, Linux offers a relatively comfy, powerful and (still) safe [unix](unix.md)/[POSIX](posix.md) environment which means it can be drop-in replaced for another unix-like system without this causing you many trouble, so using Linux is at this point considered OK (until Microsoft completely seizes it at which point we migrate probably to [BSD](bsd.md)). It can be made fairly [minimal](minimalism.md) and [LRS](lrs.md)/[suckless](suckless.md) friendly.

Linux is so called monolithic kernel and is more or less [bloat](bloat.md). However it "[just works](just_works.md)" and has a great [hardware](hardware.md) support so it wins many users over alternatives such as BSD.

Some alternatives to Linux are:

- [GNU Hurd](hurd.md), an unfinished (but somewhat usable) kernel developed by [GNU](gnu.md) itself.
- [BSD](bsd.md) operating systems such as [FreeBSD](freebsd.md), [NetBSD](netbsd.md) and [OpenBSD](openbsd.md) (best from the [LRS](lrs.md) point of view)
- [bare metal](bare_metal.md) UwU
- TODO: MOAR

## History

TODOOOOOOOOOOO